using UnityEngine;
using System.Collections;

public class Bullet : MonoBehaviour {

public float speed = 1.0f;
public float lifeTime = 1.0f;
public float damage = 1.0f;
public Player pScript;
private float decayTime;

public GameControl gControl;
private bool pause = true;

	// Use this for initialization
	void Start () {
		gControl = (GameObject.FindWithTag("GameControl")).GetComponent<GameControl>();
	}

	
	// Update is called once per frame
	void Update () {	
		if(!pause) {
			transform.Translate(Vector3.forward * Time.deltaTime * speed);
			
			if(Vector3.Distance(transform.position, Vector3.zero) > 15.0f) { //Out of map?
				killMe();
			}
			decayTime += Time.deltaTime;
			if(decayTime > lifeTime) {
				killMe();
			}
		}
		pause = gControl.pause;
	}
	
	void OnTriggerEnter(Collider col) {
		Bacteria bScript = col.gameObject.GetComponent<Bacteria>();
		if(bScript != null) {
			AudioSource.PlayClipAtPoint(audio.clip, Vector3.zero);
			bScript.gotHit(damage);
		}
		killMe();
	}

	
	void killMe() {
		StopCoroutine("decay");
		pScript.regainBullet();
		Destroy(gameObject);
	}
}
