using UnityEngine;
using System.Collections;

public class Player : MonoBehaviour {

public Camera cam;
public float speed = 10.0f;
public GameObject turret;
private Vector3 mousePos;
public GameObject bullet;
public Transform barrelExitPoint;
public int maxBullets;
public int currentBullets = 0;
public float bulletSpeed;
public float bulletLife;
public float bulletDamage = 1.0f;
private bool pause = true;
private GameControl gControl;
public Texture[] tex;
public GameObject playerMesh;
private bool readyToFire = true;

	// Use this for initialization
	void Start () {
	gControl = (GameObject.FindWithTag("GameControl")).GetComponent<GameControl>();
	
	}
	
	// Update is called once per frame
	void Update () {
		if(!pause) {
			float xMov = Input.GetAxis("Horizontal") * Time.deltaTime * speed;
			float zMov = Input.GetAxis("Vertical") * Time.deltaTime * speed;
			Vector3 movDir = new Vector3(xMov, 0, zMov);
			
			transform.Translate(movDir);
			
			//Rotate turret towards mouse	
			mousePos = cam.ScreenToWorldPoint(Input.mousePosition);
			mousePos.y = 0;	
			Vector3 myPos = new Vector3(transform.position.x, 0, transform.position.z);
			Vector3 relativePos = mousePos - myPos;
			Quaternion toRot = Quaternion.LookRotation(relativePos);
			turret.transform.rotation = toRot;
			
			if(Input.GetMouseButton(0) && readyToFire) {
				tryFire(movDir);
			}
		}
		pause = gControl.pause;
	}

	
	void tryFire(Vector3 movDir) {
		if(currentBullets < maxBullets) {
			currentBullets++;
			readyToFire = false;
			StartCoroutine(fireReload());
			StartCoroutine(shootFace());
			GameObject s = (GameObject)Instantiate(bullet, barrelExitPoint.position, turret.transform.rotation);
			Bullet b = s.GetComponent<Bullet>();
			b.pScript = this;
			b.speed = bulletSpeed;
			b.lifeTime = bulletLife;
			b.damage = bulletDamage;
			
			audio.PlayOneShot(audio.clip);
		}
	}
	IEnumerator fireReload() {
		yield return new WaitForSeconds(0.1f);
		readyToFire = true;
	}
	IEnumerator shootFace() {
		playerMesh.renderer.material.mainTexture = tex[1];
		yield return new WaitForSeconds(0.1f);
		playerMesh.renderer.material.mainTexture = tex[0];
	}
	
	public void regainBullet() {
		currentBullets--;
		if(currentBullets < 0) {
			currentBullets = 0;
		}
	}
}
